#include <Servo.h>
#include <Wire.h>
#include "botProtocol.h"
 
Servo svoPan;
Servo svoTilt;
Servo svoClaw;

const int panMid = 115;
const int panDev = 50;
 
const int tiltMid = 140;
const int tiltDev = 40;
 
const int clawMid = 90;
const int clawDev = 40;
 
volatile int pan = 0;
volatile int tilt  = 0;
volatile int claw = 50;
 
/*********************************************************************************
 */
void setup() 
{
  // set up the servos
  svoPan.attach(9);
  svoTilt.attach(10);
  svoClaw.attach(11);
 
  // now set up the comms to the botControl arduino 
  Wire.begin(I2C_CLAW);
  Wire.onReceive(receiveEvent);

Serial.begin(9600);
delay(100);
Serial.println("hello");
} 
 
/*********************************************************************************
 */
void loop() 
{
  int tmp;
  
  tmp = map(pan, -100, 100, panMid - panDev, panMid + panDev);
  svoPan.write(tmp);

  tmp = map(tilt, -100, 100, tiltMid - tiltDev, tiltMid + tiltDev);
  svoTilt.write(tmp);

  tmp = map(claw, 0, 100, clawMid + clawDev, clawMid - clawDev);
  svoClaw.write(tmp);

  delay(100);
} 



/********************************************************************************
 */
void receiveEvent(int howMany)
{
Serial.println("Recieved message");
  char ch;
  int i;
  char szVal[CMD_VAL_LEN + 1];
  while(Wire.available() > 0)
  {
    ch = Wire.receive();
Serial.println(ch);
    switch(ch)
    {
    case CMDS_CLAW:
      ch = Wire.receive();
Serial.println(ch);
      memset(szVal, 0x00, CMD_VAL_LEN + 1);
      for(i = 0; i < CMD_VAL_LEN; i++)
      {
        szVal[i] = Wire.receive();
      }
      switch(ch)
      {
      case CMD_CLAW_PAN:
        pan = atoi(szVal);
        break;
      case CMD_CLAW_PAN_NEG:
        pan = -atoi(szVal);
        break;
      case CMD_CLAW_TILT:
        tilt = atoi(szVal);
        break;
      case CMD_CLAW_TILT_NEG:
        tilt = -atoi(szVal);
        break;
      case CMD_CLAW_OPEN:
        claw = atoi(szVal);
        break;
      case CMD_CLAW_OPEN_PLUS:
        claw += atoi(szVal);
        if(claw > 100)
          claw = 100;
        break;
      case CMD_CLAW_OPEN_NEG:
        claw -= atoi(szVal);
        if(claw < 0)
          claw = 0;
        break;
      }
      continue;
      
    }

    // something we don't care about
    while(Wire.available() > 0)
    {
      ch = Wire.receive();
    }
  }
}

